!     
!     履歴
!     2013/06/27 村橋 究理基　新規作成
program yenmass
implicit none

real(4) :: average   ! 平均
real(4) :: variance  ! 分散
real(4) :: variance2 ! 分散その2
real(4) :: sum       ! 和
real(4) :: data(30)  ! 元データ
integer :: i         ! ループ変数
integer :: nmax      ! データ総数

!initialize
nmax = 30
sum = 0.0
average = 0.0
variance = 0.0
variance2 = 0.0

! ファイル読み込み
open(10, file="1yen_data.dat", status="old")

do i = 1, nmax
   read(10, *) data(i)
enddo

close(10)

! 平均を計算する
do i = 1, nmax
   sum = sum + data(i)
enddo

average = sum / real(nmax)

! 分散を計算する
sum = 0.0

do i = 1, nmax
   sum = sum + (data(i) * data(i))
enddo

variance = sum / real(nmax)

variance = variance - (average * average)

! 分散を計算する その2
sum = 0.0

do i = 1, nmax
   sum = sum + (data(i) - average)**2
enddo

variance2 = sum / real(nmax)

!結果の出力
write(*, *) 'average   = ', average
write(*, *) 'variance  = ', variance
write(*, *) 'variance2 = ', variance2

endprogram
